<template>
  <Transition name="podcast">
  <div class="podcast" v-if="show && mounted">
    <div class="podcast-title text-shadow">{{data.name}}</div>
    <div class="podcast-audio">
      <easy-spinner size="2.5em" class="audio-spinner" type="circular" color="rgb(170, 170, 200)" v-if="!audioLoaded" />
      <audio controls ref="audio" :class="{'loading': !audioLoaded}"><source :src="fileUrl" type="audio/mpeg"></audio>
    </div>
  <Transition name="fade-fast">
  <div v-if="isEditing" class="x-btn-podcast" @click="removePodcast" data-tool="מחק פודקאסט"></div>
  </Transition>
  </div>
  </Transition>
</template>

<script>
import { getDriveLink, deletePodcast } from '../firebase.js'

export default {
  props: ['data'],
  data() {
    return {
      fileUrl: '',
      show: true,
      mounted: false,
      audioLoaded: false
    }
  },
  mounted() {
    this.mounted = true
    this.getFileURL()
    Promise.resolve().then(()=>{
      this.addLoadListener()
    })
  },
  methods: {
    getFileURL() {
      this.fileUrl = getDriveLink(this.data.link)
    },
    addLoadListener() {
      this.$refs.audio.addEventListener("canplay", () => {
        this.audioLoaded = true
      })
    },
    removePodcast() {
      if (window.confirm(`למחוק את פודקאסט: ${this.data.name} ?`)) {
        deletePodcast(this.data.id)
      }
    }
  },
  computed: {
    isEditing() {
      return this.$store.state.isEditing
    }
  }
}
</script>

<style>

.podcast {
  position: relative;
  padding: 2em;
  padding-top: 0;
  margin: 2em 0;
  border-radius: 999px;
  background: #fff;
  box-shadow: 0 0 1em rgb(238, 238, 255);
  box-shadow: 0 0 1em var(--lightBlue);
  width: 100%;
  display: flex;
  flex-direction: column;
  align-items: center;
}

.podcast-title {
  padding: 1em;
  font-weight: bold;
  text-align: center;
  font-size: 1.5em;
  color: var(--blue);
}

.podcast-audio {
  width: 100%;
  display: flex;
  justify-content: center;
  align-items: center;  
}

.podcast-audio audio {
  width: 100%;
  transition: opacity .2s;
  border-radius: 5em;
}

.podcast-audio audio.loading {
  opacity: .2;
  pointer-events: none;
}

.audio-spinner {
  position: absolute;
  z-index: 1;
}

.x-btn-podcast {
  font-weight: normal;
  cursor: pointer;
  position: absolute;
  left: 50%;
  top: 0;
  transform: translate(-50%, -50%);
  --size: calc(2.5rem + .5em);
  height: var(--size);
  width: var(--size);
  background-image: url(../assets/x.svg);
  background-size: cover;
}

</style>